import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsCourseschedule {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  AreaName?: string;
  GradeName?: string;
  ClassGroup?: string;
  TimeStart!: string;
  TimeEnd!: string;
  WeekDay!: number;
  SubjectName?: string;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsCoursescheduleSchema = defineEntity({
  class: ScsCourseschedule,
  comment: '课表',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    AreaName: p.string().name('AreaName').nullable().comment('区域名称'),
    GradeName: p.string().name('GradeName').nullable().comment('届'),
    ClassGroup: p.string().name('ClassGroup').nullable().comment('班级分组'),
    TimeStart: p.time().name('TimeStart').comment('开始时间'),
    TimeEnd: p.time().name('TimeEnd').comment('结束时间'),
    WeekDay: p.integer().name('WeekDay').comment('周几'),
    SubjectName: p.string().name('SubjectName').nullable().comment('学科'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
